#include<iostream>
#include<math.h>
#include<cstdlib>
#include "los_isaac.h"
#include<fstream>		

using namespace std;

int oblicz_kierunek (int licznik_wezl, int dlugosc, int t1[][16], int nr_kierunku)
{
	if(nr_kierunku==1) //north direction
	{
		int North=0;
		if	   (licznik_wezl==dlugosc+2)				/*North-west particle  	   (#1)*/	North = licznik_wezl + dlugosc - 2;							
		else if(licznik_wezl==dlugosc*dlugosc)			/*North-east particle	   (#2)*/	North = licznik_wezl + dlugosc - 2;							
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*South-east particle	   (#3)*/	North = licznik_wezl - 1;
		else if(licznik_wezl==dlugosc*2)				/*South-west particle	 	(#4)*/	North = licznik_wezl - 1;
		else if(t1[licznik_wezl][1]==1)					/*North particles			(#5)*/	North = licznik_wezl + dlugosc - 2;							
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*East particles				(#6)*/	North = licznik_wezl - 1;
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*South particles			(#7)*/	North = licznik_wezl - 1;
		else if(t1[licznik_wezl][0]==1)					/*West particles			   (#8)*/	North = licznik_wezl - 1;
		else											/*Rest 						(#9)*/	North = licznik_wezl - 1;
		return North;
	}

	else if(nr_kierunku==2) //north-east direction
	{
		int NorthEast=0;
		if	   (licznik_wezl==dlugosc+2)				/*North-west particle 	   (#1)*/	NorthEast = licznik_wezl + dlugosc * 2 - 1;					
		else if(licznik_wezl==dlugosc*dlugosc)			/*North-east particle  	   (#2)*/	NorthEast = dlugosc * 2;									
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*South-east particle	   (#3)*/	NorthEast = licznik_wezl - (dlugosc-2) * (dlugosc+1) - 1;	
		else if(licznik_wezl==dlugosc*2)				/*South-west particle	   (#4)*/	NorthEast = licznik_wezl + dlugosc;
		else if(t1[licznik_wezl][1]==1)					/*North particles			 (#5)*/	NorthEast = licznik_wezl + dlugosc * 2 - 1;					
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*East particles			 (#6)*/	NorthEast = licznik_wezl - (dlugosc-2) * (dlugosc+1) - 1;
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*South particles			 (#7)*/	NorthEast = licznik_wezl + dlugosc;
		else if(t1[licznik_wezl][0]==1)					/*West particles			(#8)*/	NorthEast = licznik_wezl + dlugosc;
		else											/*Rest 						 (#9)*/	NorthEast = licznik_wezl + dlugosc;
		return NorthEast;
	}

	else if(nr_kierunku==3) // east direction
	{
		int East=0;
		if	   (licznik_wezl==dlugosc+2)				/*North-west particle  	   (#1)*/	East = licznik_wezl + dlugosc + 1;
		else if(licznik_wezl==dlugosc*dlugosc)			/*North-east particle  	   (#2)*/	East = licznik_wezl - (dlugosc-2) * (dlugosc+1);			
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*South-east particle	   (#3)*/	East = licznik_wezl - (dlugosc-2) * (dlugosc+1);			
		else if(licznik_wezl==dlugosc*2)				/*South-west particle	   (#4)*/	East = licznik_wezl + dlugosc + 1;
		else if(t1[licznik_wezl][1]==1)					/*North particles 			(#5)*/	East = licznik_wezl + dlugosc + 1;
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*East particles			(#6)*/	East = licznik_wezl - (dlugosc-2) * (dlugosc+1);			
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*South particles			(#7)*/	East = licznik_wezl + dlugosc + 1;
		else if(t1[licznik_wezl][0]==1)					/*West particles			  (#8)*/	East = licznik_wezl + dlugosc + 1;
		else											/*Rest  					(#9)*/	East = licznik_wezl + dlugosc + 1;
		return East;
	}

	else if(nr_kierunku==4) //south-east direction
	{
		int SouthEast=0;
		if	   (licznik_wezl==dlugosc+2)				/*(#1)*/	SouthEast = licznik_wezl + dlugosc + 2;
		else if(licznik_wezl==dlugosc*dlugosc)			/*(#2)*/	SouthEast = licznik_wezl - (dlugosc-2) * (dlugosc+1) + 1;	
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*(#3)*/	SouthEast = dlugosc + 2;								
		else if(licznik_wezl==dlugosc*2)				/*(#4)*/	SouthEast = licznik_wezl + 3;							
		else if(t1[licznik_wezl][1]==1)					/*(#5)*/	SouthEast = licznik_wezl + dlugosc + 2;
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*(#6)*/	SouthEast = licznik_wezl - (dlugosc-2) * (dlugosc+1) + 1;
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*(#7)*/	SouthEast = licznik_wezl + 3;								
		else if(t1[licznik_wezl][0]==1)					/*(#8)*/	SouthEast = licznik_wezl + dlugosc + 2;
		else											/*(#9)*/	SouthEast = licznik_wezl + dlugosc + 2;
		return SouthEast;
	}

	else if(nr_kierunku==5) // south direction
	{
		int South=0;
		if	   (licznik_wezl==dlugosc+2)				/*(#1)*/	South = licznik_wezl + 1;
		else if(licznik_wezl==dlugosc*dlugosc)			/*(#2)*/	South = licznik_wezl + 1;
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*(#3)*/	South = licznik_wezl - dlugosc + 2;						
		else if(licznik_wezl==dlugosc*2)				/*(#4)*/	South = licznik_wezl - dlugosc + 2;					
		else if(t1[licznik_wezl][1]==1)					/*(#5)*/	South = licznik_wezl + 1;
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*(#6)*/	South = licznik_wezl + 1;
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*(#7)*/	South = licznik_wezl - dlugosc + 2;						
		else if(t1[licznik_wezl][0]==1)					/*(#8)*/	South = licznik_wezl + 1;
		else											/*(#9)*/	South = licznik_wezl + 1;
		return South;
	}

	else if(nr_kierunku==6) //south-west direction
	{
		int SouthWest=0;
		if	   (licznik_wezl==dlugosc+2)				/*(#1)*/	SouthWest = licznik_wezl + (dlugosc-2) * (dlugosc+1) + 1;
		else if(licznik_wezl==dlugosc*dlugosc)			/*(#2)*/	SouthWest = licznik_wezl - dlugosc;
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*(#3)*/	SouthWest = licznik_wezl - dlugosc * 2 + 1;				
		else if(licznik_wezl==dlugosc*2)				/*(#4)*/	SouthWest = dlugosc * dlugosc;							
		else if(t1[licznik_wezl][1]==1)					/*(#5)*/	SouthWest = licznik_wezl - dlugosc;
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*(#6)*/	SouthWest = licznik_wezl - dlugosc;
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*(#7)*/	SouthWest = licznik_wezl - dlugosc * 2 + 1;				
		else if(t1[licznik_wezl][0]==1)					/*(#8)*/	SouthWest = licznik_wezl + (dlugosc-2) * (dlugosc+1) + 1;	
		else											/*(#9)*/	SouthWest = licznik_wezl - dlugosc;
		return SouthWest;
	}

	else if(nr_kierunku==7) //west direction
	{
		int West=0;
		if	   (licznik_wezl==dlugosc+2)				/*(#1)*/	West = licznik_wezl + (dlugosc-2) * (dlugosc+1);		
		else if(licznik_wezl==dlugosc*dlugosc)			/*(#2)*/	West = licznik_wezl - dlugosc - 1;
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*(#3)*/	West = licznik_wezl - dlugosc - 1;
		else if(licznik_wezl==dlugosc*2)				/*(#4)*/	West = licznik_wezl + (dlugosc-2) * (dlugosc+1);		
		else if(t1[licznik_wezl][1]==1)					/*(#5)*/	West = licznik_wezl - dlugosc - 1;
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*(#6)*/	West = licznik_wezl - dlugosc - 1;
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*(#7)*/	West = licznik_wezl - dlugosc - 1;
		else if(t1[licznik_wezl][0]==1)					/*(#8)*/	West = licznik_wezl + (dlugosc-2) * (dlugosc+1);			
		else											/*(#9)*/	West = licznik_wezl - dlugosc - 1;
		return West;
	}

	else if(nr_kierunku==8) //north-west direction
	{
		int NorthWest=0;
		if	   (licznik_wezl==dlugosc+2)				/*(#1)*/	NorthWest = (dlugosc + 1) * dlugosc - 2;					
		else if(licznik_wezl==dlugosc*dlugosc)			/*(#2)*/	NorthWest = licznik_wezl - 3;								
		else if(licznik_wezl==(dlugosc+1)*dlugosc-2)	/*(#3)*/	NorthWest = licznik_wezl - dlugosc - 2;
		else if(licznik_wezl==dlugosc*2)				/*(#4)*/	NorthWest = licznik_wezl + (dlugosc-2) * (dlugosc+1) - 1;
		else if(t1[licznik_wezl][1]==1)					/*(#5)*/	NorthWest = licznik_wezl - 3;								
		else if(t1[licznik_wezl][0]==dlugosc-1)			/*(#6)*/	NorthWest = licznik_wezl - dlugosc - 2;
		else if(t1[licznik_wezl][1]==dlugosc-1)			/*(#7)*/	NorthWest = licznik_wezl - dlugosc - 2;
		else if(t1[licznik_wezl][0]==1)					/*(#8)*/	NorthWest = licznik_wezl + (dlugosc-2) * (dlugosc+1) - 1;	
		else											/*(#9)*/	NorthWest = licznik_wezl - dlugosc - 2;
		return NorthWest;
	}
	else
	{
		cout<<"wrong direction"<<endl;
		getch();
	}
}

int oblicz_licznik_podstaw (int licznik_wezl, int dlugosc, int tab1[][16], int direction)
{
	int podstaw=0;

// PERIODIC BOUNDARY CONDITIONS
	if (direction==1 /*  North   */)
	{
		//cout<<"North"<<endl;
		if (tab1[licznik_wezl][1]==1)				 //Particle out of upper part of domain
				podstaw=licznik_wezl - 2 + dlugosc;						// frame of domain
		else 	podstaw=licznik_wezl - 1;								// inside domain
	}

	if (direction==5 /*  South   */)
	{
		//cout<<"South"<<endl;
		if (tab1[licznik_wezl][1]==dlugosc-1)		//Particle out of lower part of domain
				podstaw=licznik_wezl + 2 - dlugosc;						//frame of domain
		else 	podstaw=licznik_wezl + 1;								//inside domain
	}

	if (direction==3 /*   East   */)
	{
		//cout<<"East"<<endl;
		if (tab1[licznik_wezl][0]==dlugosc-1)		//
				podstaw=licznik_wezl - (dlugosc - 2) * (dlugosc + 1);	//frame of domain
		else 	podstaw=licznik_wezl + dlugosc + 1;						//inside domain
	}

	if (direction==7 /*   West   */)
	{
		//cout<<"West"<<endl;
		if (tab1[licznik_wezl][0]==1)				//Jeœli komórka wskoczy na praw¹ ramkê
				podstaw=licznik_wezl + (dlugosc - 2) * (dlugosc + 1);	//frame of domain
		else 	podstaw=licznik_wezl - dlugosc - 1;						//inside domain
	}

	if (direction==2 /*North-East*/)
	{
		//cout<<"North-East"<<endl;
		if(licznik_wezl==dlugosc*dlugosc)						//right upper corner
		{
			podstaw=dlugosc * 2;
		}
		else if(tab1[licznik_wezl][0]==dlugosc-1)			//right side
		{
			podstaw=licznik_wezl - (dlugosc - 1) * dlugosc + 1;
		}
		else if(tab1[licznik_wezl][1]==1)					//up
		{
			podstaw=licznik_wezl + dlugosc * 2 - 1;
		}
		else	podstaw=licznik_wezl + dlugosc;			//inside grid
	}

	if (direction==4 /*South-East*/)
	{
		//cout<<"South-East"<<endl;
		if(licznik_wezl==(dlugosc+1)*dlugosc-2)					//lower right corner
		{
			podstaw=dlugosc + 2;
		}
		else if(tab1[licznik_wezl][0]==dlugosc-1)			//right side
		{
			podstaw=licznik_wezl - (dlugosc - 2) * (dlugosc + 1) + 1;
		}
		else if(tab1[licznik_wezl][1]==dlugosc-1)			//down
		{
			podstaw=licznik_wezl + 3;
		}
		else	podstaw=licznik_wezl + dlugosc + 2;		//inside grid
	}

	if (direction==6 /*South-West*/)
	{
		//cout<<"South-West"<<endl;
		if(licznik_wezl==dlugosc*2)								//left down corner
		{
			podstaw=dlugosc * dlugosc;
		}
		else if(tab1[licznik_wezl][0]==1)					//left side
		{
			podstaw=licznik_wezl + (dlugosc - 1) * dlugosc - 1;
		}
		else if(tab1[licznik_wezl][1]==dlugosc-1)			//down
		{
			podstaw=licznik_wezl - dlugosc * 2 + 1;
		}
		else	podstaw=licznik_wezl - dlugosc;			//inside grid
	}

	if (direction==8 /*North-West*/)
	{
		//cout<<"North-West"<<endl;
		if(licznik_wezl==dlugosc+2)								//upper left corner
		{
			podstaw=(dlugosc + 1) * dlugosc - 2;
		}
		else if(tab1[licznik_wezl][0]==1)					//left side
		{
			podstaw=licznik_wezl + (dlugosc - 2) * (dlugosc + 1) - 1;
		}
		else if(tab1[licznik_wezl][1]==1)					//up
		{
			podstaw=licznik_wezl - 3;
		}
		else	podstaw=licznik_wezl - dlugosc - 2;		//inside domain
	}

	return podstaw;
}

bool sprawdz_ruch(int licznik_wezl, int dlugosc, int t[][16], int t1[][16], int roza, bool movement)
{
	int licznik_podstaw=oblicz_licznik_podstaw(licznik_wezl, dlugosc, t1, roza);				
	t1[licznik_wezl][14]=1;																		// "Checking" the particle during analysing domain

	//Designation of neighbours' cordinates
	int North	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 1);
	int NorthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 2);
	int East	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 3);
	int SouthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 4);
	int South	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 5);
	int SouthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 6);
	int West	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 7);
	int NorthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 8);


	if(t[licznik_podstaw][2]==0)
	{
		// If particle && has a number ... && wasn't yet "checked" && is within the analysed aggregate && aggregate nr != zero//
		if(t1[North][2]==1 && t1[North][3]>0 && t1[North][14]==0 && t1[licznik_wezl][12]==t1[North][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (North, dlugosc, t, t1, roza, movement);

		if(t1[NorthEast][2]==1 && t1[NorthEast][3]>0 && t1[NorthEast][14]==0 && t1[licznik_wezl][12]==t1[NorthEast][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (NorthEast, dlugosc, t, t1, roza, movement);

		if(t1[East][2]==1 && t1[East][3]>0 && t1[East][14]==0 && t1[licznik_wezl][12]==t1[East][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (East, dlugosc, t, t1, roza, movement);

		if(t1[SouthEast][2]==1 && t1[SouthEast][3]>0 && t1[SouthEast][14]==0 && t1[licznik_wezl][12]==t1[SouthEast][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (SouthEast, dlugosc, t, t1, roza, movement);

		if(t1[South][2]==1 && t1[South][3]>0 && t1[South][14]==0 && t1[licznik_wezl][12]==t1[South][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (South, dlugosc, t, t1, roza, movement);

		if(t1[SouthWest][2]==1 && t1[SouthWest][3]>0 && t1[SouthWest][14]==0 && t1[licznik_wezl][12]==t1[SouthWest][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (SouthWest, dlugosc, t, t1, roza, movement);

		if(t1[West][2]==1 && t1[West][3]>0 && t1[West][14]==0 && t1[licznik_wezl][12]==t1[West][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (West, dlugosc, t, t1, roza, movement);

		if(t1[NorthWest][2]==1 && t1[NorthWest][3]>0 && t1[NorthWest][14]==0 && t1[licznik_wezl][12]==t1[NorthWest][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (NorthWest, dlugosc, t, t1, roza, movement);
	}
	else if(t[licznik_podstaw][2]==1 && t[licznik_wezl][12]==t[licznik_podstaw][12] && t[licznik_wezl][12]!=0 && t[licznik_podstaw][12]!=0)
	{
		//If particle && has a number ... && wasn't yet "checked" && is within the analysed aggregate && aggregate nr != zero//
		if(t1[North][2]==1 && t1[North][3]>0 && t1[North][14]==0 && t1[licznik_wezl][12]==t1[North][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (North, dlugosc, t, t1, roza, movement);

		if(t1[NorthEast][2]==1 && t1[NorthEast][3]>0 && t1[NorthEast][14]==0 && t1[licznik_wezl][12]==t1[NorthEast][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (NorthEast, dlugosc, t, t1, roza, movement);

		if(t1[East][2]==1 && t1[East][3]>0 && t1[East][14]==0 && t1[licznik_wezl][12]==t1[East][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (East, dlugosc, t, t1, roza, movement);

		if(t1[SouthEast][2]==1 && t1[SouthEast][3]>0 && t1[SouthEast][14]==0 && t1[licznik_wezl][12]==t1[SouthEast][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (SouthEast, dlugosc, t, t1, roza, movement);

		if(t1[South][2]==1 && t1[South][3]>0 && t1[South][14]==0 && t1[licznik_wezl][12]==t1[South][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (South, dlugosc, t, t1, roza, movement);

		if(t1[SouthWest][2]==1 && t1[SouthWest][3]>0 && t1[SouthWest][14]==0 && t1[licznik_wezl][12]==t1[SouthWest][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (SouthWest, dlugosc, t, t1, roza, movement);

		if(t1[West][2]==1 && t1[West][3]>0 && t1[West][14]==0 && t1[licznik_wezl][12]==t1[West][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (West, dlugosc, t, t1, roza, movement);

		if(t1[NorthWest][2]==1 && t1[NorthWest][3]>0 && t1[NorthWest][14]==0 && t1[licznik_wezl][12]==t1[NorthWest][12] && t1[licznik_wezl][12]!=0)
			movement = sprawdz_ruch (NorthWest, dlugosc, t, t1, roza, movement);
	}
	else movement=false;

	return movement;
}

void stop_agregat(int licznik_wezl, int dlugosc, int t1[][16], int stop_table[])
{
	t1[licznik_wezl][15]=1;																		// "Checking" the particle during analysing domain

	//Designation of neighbours' cordinates//
	int North	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 1);
	int NorthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 2);
	int East	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 3);
	int SouthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 4);
	int South	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 5);
	int SouthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 6);
	int West	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 7);
	int NorthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 8);

	// If particle && wasnt "checked" yet && has the same aggregate nr && not zero && as well as its neighbour//
	if(t1[North][2]==1 && t1[North][15]==0 && t1[licznik_wezl][12]==t1[North][12] && t1[licznik_wezl][12]!=0 && t1[North][12]!=0)
		stop_agregat (North, dlugosc, t1, stop_table);

	if(t1[NorthEast][2]==1 && t1[NorthEast][15]==0 && t1[licznik_wezl][12]==t1[NorthEast][12] && t1[licznik_wezl][12]!=0 && t1[NorthEast][12]!=0)
		stop_agregat (NorthEast, dlugosc, t1, stop_table);

	if(t1[East][2]==1 && t1[East][15]==0 && t1[licznik_wezl][12]==t1[East][12] && t1[licznik_wezl][12]!=0 && t1[East][12]!=0)
		stop_agregat (East, dlugosc, t1, stop_table);

	if(t1[SouthEast][2]==1 && t1[SouthEast][15]==0 && t1[licznik_wezl][12]==t1[SouthEast][12] && t1[licznik_wezl][12]!=0 && t1[SouthEast][12]!=0)
		stop_agregat (SouthEast, dlugosc, t1, stop_table);

	if(t1[South][2]==1 && t1[South][15]==0 && t1[licznik_wezl][12]==t1[South][12] && t1[licznik_wezl][12]!=0 && t1[South][12]!=0)
		stop_agregat (South, dlugosc, t1, stop_table);

	if(t1[SouthWest][2]==1 && t1[SouthWest][15]==0 && t1[licznik_wezl][12]==t1[SouthWest][12] && t1[licznik_wezl][12]!=0 && t1[SouthWest][12]!=0)
		stop_agregat (SouthWest, dlugosc, t1, stop_table);

	if(t1[West][2]==1 && t1[West][15]==0 && t1[licznik_wezl][12]==t1[West][12] && t1[licznik_wezl][12]!=0 && t1[West][12]!=0)
		stop_agregat (West, dlugosc, t1, stop_table);

	if(t1[NorthWest][2]==1 && t1[NorthWest][15]==0 && t1[licznik_wezl][12]==t1[NorthWest][12] && t1[licznik_wezl][12]!=0 && t1[NorthWest][12]!=0)
		stop_agregat (NorthWest, dlugosc, t1, stop_table);

	// Not moving a particle within an aggregate part 1//

	stop_table[licznik_wezl]=1;				//Marking a particle of some aggregate to stop
}

void ruch_agregat(int licznik_wezl, int dlugosc, int t[][16], int t1[][16], int m_help[][4], int roza)
{
	int licznik_podst=oblicz_licznik_podstaw(licznik_wezl, dlugosc, t1, roza);					
	t1[licznik_wezl][15]=1;																		//"Checking" the particle during analysing domain

	//Designation of neighbours' coordinates
	int North	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 1);
	int NorthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 2);
	int East	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 3);
	int SouthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 4);
	int South	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 5);
	int SouthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 6);
	int West	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 7);
	int NorthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 8);

	// If particle && wasnt "checked" yet && has the same aggregate nr && not zero && as well as its neighbour//
	if(t1[North][2]==1 && t1[North][15]==0 && t1[licznik_wezl][12]==t1[North][12] && t1[licznik_wezl][12]!=0 && t1[North][12]!=0)
		ruch_agregat (North, dlugosc, t, t1, m_help, roza);

	if(t1[NorthEast][2]==1 && t1[NorthEast][15]==0 && t1[licznik_wezl][12]==t1[NorthEast][12] && t1[licznik_wezl][12]!=0 && t1[NorthEast][12]!=0)
		ruch_agregat (NorthEast, dlugosc, t, t1, m_help, roza);

	if(t1[East][2]==1 && t1[East][15]==0 && t1[licznik_wezl][12]==t1[East][12] && t1[licznik_wezl][12]!=0 && t1[East][12]!=0)
		ruch_agregat (East, dlugosc, t, t1, m_help, roza);

	if(t1[SouthEast][2]==1 && t1[SouthEast][15]==0 && t1[licznik_wezl][12]==t1[SouthEast][12] && t1[licznik_wezl][12]!=0 && t1[SouthEast][12]!=0)
		ruch_agregat (SouthEast, dlugosc, t, t1, m_help, roza);

	if(t1[South][2]==1 && t1[South][15]==0 && t1[licznik_wezl][12]==t1[South][12] && t1[licznik_wezl][12]!=0 && t1[South][12]!=0)
		ruch_agregat (South, dlugosc, t, t1, m_help, roza);

	if(t1[SouthWest][2]==1 && t1[SouthWest][15]==0 && t1[licznik_wezl][12]==t1[SouthWest][12] && t1[licznik_wezl][12]!=0 && t1[SouthWest][12]!=0)
		ruch_agregat (SouthWest, dlugosc, t, t1, m_help, roza);

	if(t1[West][2]==1 && t1[West][15]==0 && t1[licznik_wezl][12]==t1[West][12] && t1[licznik_wezl][12]!=0 && t1[West][12]!=0)
		ruch_agregat (West, dlugosc, t, t1, m_help, roza);

	if(t1[NorthWest][2]==1 && t1[NorthWest][15]==0 && t1[licznik_wezl][12]==t1[NorthWest][12] && t1[licznik_wezl][12]!=0 && t1[NorthWest][12]!=0)
		ruch_agregat (NorthWest, dlugosc, t, t1, m_help, roza);


	// Moving a particle/aggregat part 1

	m_help[licznik_podst][0]=1;			//--> Input of ne data about an aggregate to suportive table
	m_help[licznik_podst][1]=t1[licznik_wezl][3];
	m_help[licznik_podst][2]=t1[licznik_wezl][12];
	t[licznik_wezl][2]=0;				//--> Delating aggregate from table 't'
	t[licznik_wezl][3]=0;
	t[licznik_wezl][12]=0;
}

void zapisz_agregat(int licznik_wezl, int dlugosc, int t[][16], int t1[][16], int m_help[][4], int roza)
{
	int licznik_podst=oblicz_licznik_podstaw(licznik_wezl, dlugosc, t1, roza);					
	m_help[licznik_wezl][3]=1;																	// "Checking" partlicle during analysing table

	//Designation of neighbours' cordinates
	int North	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 1);
	int NorthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 2);
	int East	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 3);
	int SouthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 4);
	int South	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 5);
	int SouthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 6);
	int West	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 7);
	int NorthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 8);

	// If particle && wasn't "checked" yet && has the same aggregate number && not zero && and the analysed neigbour neither
	if(t1[North][2]==1 && m_help[North][3]==0 && t1[licznik_wezl][12]==t1[North][12] && t1[licznik_wezl][12]!=0 && t1[North][12]!=0)
		zapisz_agregat (North, dlugosc, t, t1, m_help, roza);

	if(t1[NorthEast][2]==1 && m_help[NorthEast][3]==0 && t1[licznik_wezl][12]==t1[NorthEast][12] && t1[licznik_wezl][12]!=0 && t1[NorthEast][12]!=0)
		zapisz_agregat (NorthEast, dlugosc, t, t1, m_help, roza);

	if(t1[East][2]==1 && m_help[East][3]==0 && t1[licznik_wezl][12]==t1[East][12] && t1[licznik_wezl][12]!=0 && t1[East][12]!=0)
		zapisz_agregat (East, dlugosc, t, t1, m_help, roza);

	if(t1[SouthEast][2]==1 && m_help[SouthEast][3]==0 && t1[licznik_wezl][12]==t1[SouthEast][12] && t1[licznik_wezl][12]!=0 && t1[SouthEast][12]!=0)
		zapisz_agregat (SouthEast, dlugosc, t, t1, m_help, roza);

	if(t1[South][2]==1 && m_help[South][3]==0 && t1[licznik_wezl][12]==t1[South][12] && t1[licznik_wezl][12]!=0 && t1[South][12]!=0)
		zapisz_agregat (South, dlugosc, t, t1, m_help, roza);

	if(t1[SouthWest][2]==1 && m_help[SouthWest][3]==0 && t1[licznik_wezl][12]==t1[SouthWest][12] && t1[licznik_wezl][12]!=0 && t1[SouthWest][12]!=0)
		zapisz_agregat (SouthWest, dlugosc, t, t1, m_help, roza);

	if(t1[West][2]==1 && m_help[West][3]==0 && t1[licznik_wezl][12]==t1[West][12] && t1[licznik_wezl][12]!=0 && t1[West][12]!=0)
		zapisz_agregat (West, dlugosc, t, t1, m_help, roza);

	if(t1[NorthWest][2]==1 && m_help[NorthWest][3]==0 && t1[licznik_wezl][12]==t1[NorthWest][12] && t1[licznik_wezl][12]!=0 && t1[NorthWest][12]!=0)
		zapisz_agregat (NorthWest, dlugosc, t, t1, m_help, roza);

	// Moving particle/aggregate part 2
	t[licznik_podst][2]  = m_help[licznik_podst][0];		//--> Transcription data  from supportive to main table 't'
	t[licznik_podst][3]  = m_help[licznik_podst][1];
	t[licznik_podst][12] = m_help[licznik_podst][2];
}

void sasiedztwo_tabl (int licznik_wezl, int dlugosc, int t1[][16], double prawdopodob, double plos, int licznik_cz_agregat[1])
{
		// counting particles within an aggregate &Desingation of their coordinaters

	t1[licznik_wezl][13]=1;		//"checking" particle while analysing table

	//Designation of neighbours'  coordinates
	int North	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 1);
	int NorthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 2);
	int East	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 3);
	int SouthEast = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 4);
	int South	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 5);
	int SouthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 6);
	int West	  = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 7);
	int NorthWest = oblicz_kierunek	(licznik_wezl, dlugosc, t1, 8);

	//Calculations for the neighbourhood

	if(t1[North][2]==1)
	{
		t1[licznik_wezl][4]=t1[North][3];		

		if(t1[North][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[North][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (North, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];		//Number of aggregate = number of particle from with we start counting
				t1[North][12]=t1[licznik_wezl][12];											//Transcription of aggregat nr on neighbouring particle
				sasiedztwo_tabl (North, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[North][13]=1;			//"checking" an empty node in neighbourhood

	if(t1[NorthEast][2]==1)
	{
		t1[licznik_wezl][5]=t1[NorthEast][3];		//information about the neighbourhood

		if(t1[NorthEast][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[NorthEast][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (NorthEast, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];		//Number of aggregate = number of particle from with we start counting
				t1[NorthEast][12]=t1[licznik_wezl][12];										//Transcription of aggregat nr on neighbouring particle
				sasiedztwo_tabl (NorthEast, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[NorthEast][13]=1;		

	if(t1[East][2]==1)
	{
		t1[licznik_wezl][6]=t1[East][3];	

		if(t1[East][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[East][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (East, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];		
				t1[East][12]=t1[licznik_wezl][12];										
				sasiedztwo_tabl (East, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[East][13]=1;			

	if(t1[SouthEast][2]==1)
	{
		t1[licznik_wezl][7]=t1[SouthEast][3];	

		if(t1[SouthEast][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[SouthEast][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (SouthEast, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];	
				t1[SouthEast][12]=t1[licznik_wezl][12];										
				sasiedztwo_tabl (SouthEast, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[SouthEast][13]=1;		

	if(t1[South][2]==1)
	{
		t1[licznik_wezl][8]=t1[South][3];		

		if(t1[South][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[South][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (South, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];		
				t1[South][12]=t1[licznik_wezl][12];										
				sasiedztwo_tabl (South, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[South][13]=1;		

	if(t1[SouthWest][2]==1)
	{
		t1[licznik_wezl][9]=t1[SouthWest][3];	

		if(t1[SouthWest][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[SouthWest][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (SouthWest, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];	
				t1[SouthWest][12]=t1[licznik_wezl][12];										
				sasiedztwo_tabl (SouthWest, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[SouthWest][13]=1;		

	if(t1[West][2]==1)
	{
		t1[licznik_wezl][10]=t1[West][3];	

		if(t1[West][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[West][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (West, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];		
				t1[West][12]=t1[licznik_wezl][12];								
				sasiedztwo_tabl (West, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[West][13]=1;		

	if(t1[NorthWest][2]==1)
	{
		t1[licznik_wezl][11]=t1[NorthWest][3];	

		if(t1[NorthWest][13]==0)
		{
			if(t1[licznik_wezl][12]==t1[NorthWest][12] && t1[licznik_wezl][12]!=0)
				sasiedztwo_tabl (NorthWest, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			else if(plos<=prawdopodob)
			{
				if(t1[licznik_wezl][12]==0) t1[licznik_wezl][12]=t1[licznik_wezl][3];		
				t1[NorthWest][12]=t1[licznik_wezl][12];									
				sasiedztwo_tabl (NorthWest, dlugosc, t1, prawdopodob, plos, licznik_cz_agregat);
			}
		}
	}
	else t1[NorthWest][13]=1;		

	licznik_cz_agregat[0]=licznik_cz_agregat[0]+1;
}

int main()
{
    srand(time(NULL));

    //INITIAL PARAMETERS/
	int dlugosc=201;
    double c_zal=0.125; 									//CONCENTRATION
    double p=0.1; 											// PROBABILITY
	int wielkosc=(dlugosc-1)*(dlugosc-1)*c_zal/20;			//DETACTABLE AGGREGATE, 5% 
	int time = 1000000;

	bool przejscie;		
	int xlicznik=0, ylicznik=0, Liczba_czast=0, licznik_wezl=0, licznik_czast=0, licznik_pion=0;
	int Liczba_wezl=(dlugosc+1)*(dlugosc+1)-1;	
	int time0=0, kierunek, suma_mas_agregat=0;
	bool stop_program = false;
	double clos, c0, c, plos, sr_masa=0;
	int tablica[Liczba_wezl][16], tablica1[Liczba_wezl][16], macierz_pomocn[Liczba_wezl][4], stop_tablica[Liczba_wezl];

	// Grid

	for(xlicznik=0; xlicznik<=dlugosc; xlicznik++)
	{
		for(ylicznik=0; ylicznik<=dlugosc; ylicznik++)
		{
			tablica[licznik_wezl][0]=xlicznik;
			tablica[licznik_wezl][1]=ylicznik;

			if(xlicznik==0 || xlicznik==dlugosc || ylicznik==0 || ylicznik==dlugosc)
			{
				tablica[licznik_wezl][2]=0;
				tablica[licznik_wezl][3]=0;							
			}
			else
			{
				clos=los();
				if (clos<=c_zal)
				{
					tablica[licznik_wezl][2]=1;						
					Liczba_czast++;
				}
				else tablica[licznik_wezl][2]=0;
			}

			if (tablica[licznik_wezl][2]==1)
			{
				tablica[licznik_wezl][3]=Liczba_czast;				
				tablica[licznik_wezl][12]=tablica[licznik_wezl][3];		
			}
			else
			{
				tablica[licznik_wezl][3]=0;
				tablica[licznik_wezl][12]=0;							
			}

			tablica[licznik_wezl][4]=0;
			tablica[licznik_wezl][5]=0;
			tablica[licznik_wezl][6]=0;
			tablica[licznik_wezl][7]=0;
			tablica[licznik_wezl][8]=0;
			tablica[licznik_wezl][9]=0;
			tablica[licznik_wezl][10]=0;
			tablica[licznik_wezl][11]=0;			

			tablica[licznik_wezl][12]=0;			//Nr of aggregate
			tablica[licznik_wezl][13]=0;			//check after analysing neighbourhood
			tablica[licznik_wezl][14]=0;			//check possiblity of movement
			tablica[licznik_wezl][15]=0;			//check movement
			macierz_pomocn[licznik_wezl][0] = 0;	
			macierz_pomocn[licznik_wezl][1] = 0;	
			macierz_pomocn[licznik_wezl][2] = 0;	
			macierz_pomocn[licznik_wezl][3] = 0;	
			stop_tablica[licznik_wezl] = 0;		

			licznik_wezl++;
		}
		ylicznik=0;
	}

	//How many particles within aggregate//

	int licznik_cz_agregat[1];		
	int skok_liczba_agregat=0;	
	int size_tab[Liczba_czast];		//size of an aggregate
	for(int i=0; i<=Liczba_czast; i++)	size_tab[i]=0;	


	//Information about grid//

	double Liczba_czast2=Liczba_czast;
	c0=Liczba_czast2/((dlugosc-1)*(dlugosc-1));
	cout<<"\n\n-------Initial data-------\n\n";
	cout<<"nr of particles:  "<<Liczba_czast2<<endl<<"Concentration:  "<<c_zal<<endl;
	cout<<"Obtained conc.:  "<<c0<<endl<<"Size: "<<dlugosc<<endl;
	cout<<"Probability: "<<p<<endl<<"Size of detectable aggregate: "<<wielkosc<<endl;
	cout<<"press any button to start..."<<endl<<endl;
    getch();


	FILE *fr;
	fr=fopen("wspolrzedne.txt","w");
	fprintf(fr,"%f\t %f\t %f\t %d\t %f\n", c0, c_zal, p, wielkosc, 0);
	fprintf(fr,"%d\t %d\t %d\t %d\t %d\n", dlugosc-1, 0, 0, 0, 0);


	FILE *size;
	size=fopen("Agregaty.txt","w");
	fprintf(size,"%f\t %f\n", c0, c_zal);
	fprintf(size,"%f\t %f\n", p, wielkosc);
	fprintf(size,"%d\t %d\n", dlugosc-1, 0);

	FILE *gt;
	gt=fopen("do_Matlaba.txt","w");
	fprintf(gt,"%f\t %f\t %f\n", c0, c_zal, p);
	fprintf(gt,"%d\t %d\t %d\n", wielkosc, dlugosc-1, 0);

	//--------------------------------------------------------------------------------------------------------------//
	//---------------------------------------- MAIN TIME LOOP               ----------------------------------------//
	//--------------------------------------------------------------------------------------------------------------//


	for (int nrsym=0; nrsym<=time; nrsym++)
	{

		//Checking neighbourhood and how many aggregates
		
		if(nrsym%100 == 0)	cout<<"Simulation nr: "<<nrsym<<"\tSingle particles: "<<Liczba_czast-suma_mas_agregat<<endl;

		suma_mas_agregat=0;
		sr_masa=0;
		skok_liczba_agregat=0;

		for(licznik_wezl=0; licznik_wezl<=Liczba_wezl; licznik_wezl++)
		{
			if(tablica[licznik_wezl][2]==1 && tablica[licznik_wezl][13]==0)
			{
				licznik_cz_agregat[0]=0;			
				plos=los();
				sasiedztwo_tabl(licznik_wezl, dlugosc, tablica, p, plos, licznik_cz_agregat);

				size_tab[skok_liczba_agregat]=licznik_cz_agregat[0];
				skok_liczba_agregat++;

				if(licznik_cz_agregat[0]==Liczba_czast)		stop_program = true;
				if (licznik_cz_agregat[0]>=wielkosc) 		suma_mas_agregat = suma_mas_agregat+licznik_cz_agregat[0];
				sr_masa = sr_masa+1;			
			}
			else tablica[licznik_wezl][13]=1;
		}
		sr_masa = Liczba_czast2/sr_masa;	

		for(skok_liczba_agregat; skok_liczba_agregat<=Liczba_czast; skok_liczba_agregat++)
			size_tab[skok_liczba_agregat]=0;

		//saving data txt

		fprintf(gt,"%d\t %d\t %f\n", nrsym, suma_mas_agregat, sr_masa);

		fprintf(fr,"%d\t %d\t %d\t %d\t %d\n", 0, 0, 0, 0, nrsym);
		for (licznik_wezl=0; licznik_wezl<Liczba_wezl; licznik_wezl++)
		{
			if (tablica[licznik_wezl][2]==1)
				fprintf(fr,"%d\t %d\t %d\t %d\t %d\n", tablica[licznik_wezl][0], tablica[licznik_wezl][1], tablica[licznik_wezl][3], tablica[licznik_wezl][12],0);
		}

		fprintf(size,"%d\t %d\n", 0, nrsym);
		for (skok_liczba_agregat=0; skok_liczba_agregat<=Liczba_czast; skok_liczba_agregat++)
			if(size_tab[skok_liczba_agregat]!=0)	fprintf(size,"%d\t %d\n", size_tab[skok_liczba_agregat], 0);

		if(nrsym==0)
		{
			FILE *hy;
			hy=fopen("Macierz_1.txt","w");
			for (licznik_wezl=0; licznik_wezl<Liczba_wezl; licznik_wezl++)
			{
				if (tablica[licznik_wezl][2]==1)
					fprintf(hy,"%d\t %d\t %d\t %d\n", tablica[licznik_wezl][0], tablica[licznik_wezl][1], tablica[licznik_wezl][3], tablica[licznik_wezl][12]);
			}
			fclose(hy);
		}

		//transcription of data

		for(licznik_wezl=0; licznik_wezl<=Liczba_wezl; licznik_wezl++)
		{
			for(int i=0; i<=15; i++)
			{
				tablica1[licznik_wezl][i] = tablica[licznik_wezl][i];
			}
		}

		//------------------------Moving particles-----------------------


		for(licznik_wezl=0; licznik_wezl<=Liczba_wezl; licznik_wezl++)
		{
			if (tablica1[licznik_wezl][2]==1 && tablica1[licznik_wezl][3]>0 && tablica1[licznik_wezl][14]==0)
			{
				przejscie=true;
				kierunek=(std::rand() % 8) + 1;		//Directions: 1-N, 2-NE, 3-E, 4-SE, 5-S, 6-SW, 7-W, 8-NW

				przejscie=sprawdz_ruch (licznik_wezl, dlugosc, tablica, tablica1, kierunek, przejscie);

				if(przejscie == true && stop_tablica[licznik_wezl] != 1)
				{
					ruch_agregat (licznik_wezl, dlugosc, tablica, tablica1, macierz_pomocn, kierunek);
					zapisz_agregat (licznik_wezl, dlugosc, tablica, tablica1, macierz_pomocn, kierunek);
				}
				else stop_agregat (licznik_wezl, dlugosc, tablica1, stop_tablica);
			}
		}

	
		for(licznik_wezl=0; licznik_wezl<=Liczba_wezl; licznik_wezl++)
		{
			tablica[licznik_wezl][4]=0;
			tablica[licznik_wezl][5]=0;
			tablica[licznik_wezl][6]=0;
			tablica[licznik_wezl][7]=0;
			tablica[licznik_wezl][8]=0;
			tablica[licznik_wezl][9]=0;
			tablica[licznik_wezl][10]=0;
			tablica[licznik_wezl][11]=0;
													
			tablica[licznik_wezl][13]=0;			
			tablica[licznik_wezl][14]=0;			
			tablica[licznik_wezl][15]=0;			

			macierz_pomocn[licznik_wezl][0] = 0;	
			macierz_pomocn[licznik_wezl][1] = 0;	
			macierz_pomocn[licznik_wezl][2] = 0;	
			macierz_pomocn[licznik_wezl][3] = 0;	
			stop_tablica[licznik_wezl] = 0;			
			size_tab[licznik_wezl] = 0;				
		}


		Liczba_czast=0;
		for(licznik_wezl=0; licznik_wezl<=Liczba_wezl; licznik_wezl++)
		{
			if(tablica[licznik_wezl][2]==1)	Liczba_czast++;
		}
		int roznica=Liczba_czast2-Liczba_czast;
		Liczba_czast2=Liczba_czast;
		c=Liczba_czast2/((dlugosc-1)*(dlugosc-1));


		if(c<c0)
		{
			cout<<"Concentration is lower "<<roznica<<" - sth is wrong, press any button if you want to continue"<<endl;
			c0=c;
			getch();
		}
		else if(c>c0)
		{
			cout<<"A new particle? sth is wrong"<<endl;
			getch();
		}

		if(stop_program==true)
		{
			cout<<"\nWe have one big aggregate."<<endl<<" --> Program stopped."<<endl;

			fprintf(fr,"%d\t %d\t %d\t %d\t %d\n", 0, 0, 0, 0, nrsym+1);
			for (licznik_wezl=0; licznik_wezl<Liczba_wezl; licznik_wezl++)
			{
				if (tablica[licznik_wezl][2]==1)
					fprintf(fr,"%d\t %d\t %d\t %d\t %d\n", tablica[licznik_wezl][0], tablica[licznik_wezl][1], tablica[licznik_wezl][3], tablica[licznik_wezl][12], 0);
			}
			fprintf(fr,"%s\n", "" );

			fprintf(size,"%d\t %d\n", 0, nrsym+1);
			for (skok_liczba_agregat=0; skok_liczba_agregat<=Liczba_czast; skok_liczba_agregat++)
			if(size_tab[skok_liczba_agregat]!=0)	fprintf(size,"%d\t %d\n", size_tab[skok_liczba_agregat], 0);

			FILE *ju;
			ju=fopen("Macierz_ostatnia.txt","w");
			for (licznik_wezl=0; licznik_wezl<Liczba_wezl; licznik_wezl++)
			{
				if (tablica[licznik_wezl][2]==1)
					fprintf(ju,"%d\t %d\t %d\t %d\n", tablica[licznik_wezl][0], tablica[licznik_wezl][1], tablica[licznik_wezl][3], tablica[licznik_wezl][12]);
			}
			fclose(ju);

			break;
		}
		else if(nrsym==time)
		{
			cout<<"\nToo long"<<endl<<" --> Program stopped."<<endl;

			fprintf(fr,"%d\t %d\t %d\t %d\t %d\n", 0, 0, 0, 0, nrsym+1);
		 	for (licznik_wezl=0; licznik_wezl<Liczba_wezl; licznik_wezl++)
			{
				if (tablica[licznik_wezl][2]==1)
					fprintf(fr,"%d\t %d\t %d\t %d\t %d\n", tablica[licznik_wezl][0], tablica[licznik_wezl][1], tablica[licznik_wezl][3], tablica[licznik_wezl][12], 0);
			}
			fprintf(fr,"%s\n", "" );

			fprintf(size,"%d\t %d\n", 0, nrsym+1);
			for (skok_liczba_agregat=0; skok_liczba_agregat<=Liczba_czast; skok_liczba_agregat++)
			if(size_tab[skok_liczba_agregat]!=0)	fprintf(size,"%d\t %d\n", size_tab[skok_liczba_agregat], 0);

			FILE *ju;
			ju=fopen("Macierz_ostatnia.txt","w");
			for (licznik_wezl=0; licznik_wezl<Liczba_wezl; licznik_wezl++)
			{
				if (tablica[licznik_wezl][2]==1)
					fprintf(ju,"%d\t %d\t %d\t %d\n", tablica[licznik_wezl][0], tablica[licznik_wezl][1], tablica[licznik_wezl][3], tablica[licznik_wezl][12]);
			}
			fclose(ju);
		}
	}

	fclose(fr);
	fclose(gt);
	fclose(size);

	getch();
	return 0;
}
